(ns luduverse.models.user
  (:require [korma.core :refer :all]
            [luduverse.db :refer :all]))

(defn user-id [username]
  (first (select users
          (fields :id)
          (where {:username username})
          (limit 1))))

(defn exists? [username]
  (not (empty? (user-id username))))

(defn create! [username]
  (insert users (values {:username username})))

(defn unique-user [username]
  (if-not (exists? username) (create! username))
  (user-id username))
